
# 46 tests currently

my $oldout;
my $file="t/output.txt";

sub go {
my ($class)=@_;


###########
# Eidetic #
###########

# instantiate
my $e = $class->new();
isa_ok($e,'Eidetic'); 	# test
isa_ok($e,$class); 	# test

is($e->configure(),1,"configure handles sane configuration"); # test
is($e->registerModule(name => "commands_mod", table => "user", commands => ["display","edit","search"]),1,
        "standard functions exist"); # test


# TODO
# Add a series of commands
# Run "dispatch" against them, get valid results

my ($cmd,$query,$msg);

# do_redirect
stdout_grab();
$e->do_redirect();
like(stdout_dump(),qr/Location: http/,"url without data handle is sane"); # test

stdout_grab();
$e->do_redirect( data => { 'path' => 'there', 'file' => 'this' } );
like(stdout_dump(),
	qr/Location: therethis/,"url with datahandle is sane"); # test
# TODO: test for cmd, query, msg?


# do_many
# TODO test this before do_search
my $f = new Eidetic;
isa_ok($f,"Eidetic"); 	# test
is($f->configure(
		fields => { limit_view_user => 1, },
	),1,"configure handles limit_view_user"); # test
is($f->registerModule(name => "commands_mod", table => "user", commands => ["display","search"]),1,
	"registration"); # test
stdout_grab();
eval { $f->do_many(); };
like($@,qr/Need user object/,"abort without user"); # test
stdout_dump();

stdout_grab();
eval { $f->do_many( user => 1 ); };
like($@,qr/Need table name/,"abort without table"); # test
stdout_dump();

stdout_grab();
eval { $f->do_many( 
		modulename => 'users',
		user => {
			'Permissions' => { 'admin' => 'N' },
			}
		); };
like($@,qr/Cannot access user records/,"abort on bad admin perms"); # test
stdout_dump();

stdout_grab();
eval { $e->do_many( user => 1, table => 'user' ); };
like($@,qr/Need 'on' parameter/,"abort without 'on'"); # test
stdout_dump();

stdout_grab();
eval { $e->do_many( user => 1, table => 'user', on => $main::testuid ); };
like($@,qr/Need 'command' parameter/,"abort without 'command'"); # test
stdout_dump();

stdout_grab();
eval { $e->do_many( user => 1,
                    table => 'user',
                    on => $main::testuid,
		    command => "dne",
		 ); };
like($@,qr/does not appear to exist/,"template missing for do_many"); # test
stdout_dump();

# TODO: test all template combinations
stdout_grab();
eval { $e->do_many( user => { },
                    table => 'user',
                    on => $main::testuid,
		    command => "test",
		 ); };
#like($@,qr/does not appear to exist/,"template missing for do_many"); # test
is($@,"","happy do_many"); # test
like(stdout_dump(),qr/test\.all\.page\.tmpl/s,"do_many sane output"); # test

# TODO: test args and other templates


# do_search
stdout_grab();
eval { $e->do_search(); }; # no data == "Advanced Search" on modulename
like($@,qr/does not appear to exist/,"fail without search template"); # test
stdout_dump();

stdout_grab();
eval { ($cmd,$query,$msg)=$e->do_search(
		modulename => 'mod_name',
	); }; # no data == "Advanced Search" on modulename
is($@,"","dump advanced search"); # test
like(stdout_dump(),qr/main\.tmpl.*header\.tmpl.*search\.tmpl.*Advanced Search.*footer\.tmpl/s,"advanced search template dumped"); # test
is(!defined($cmd),1,"no nextCommand"); # test
is(!defined($query),1,"no nextQuery"); # test
is(!defined($msg),1,"no noticeMsg"); # test

stdout_grab();
eval { ($cmd,$query,$msg)=$e->do_search(
		nextCommand => 'my nextCommand',
		nextQuery => 'my nextQuery',
		noticeMsg => 'my noticeMsg',
		modulename => 'mod_name',
	); }; # no data == "Advanced Search" on modulename
is($@,"","happy advanced search"); # test
like(stdout_dump(),qr/main\.tmpl.*header\.tmpl.*search\.tmpl.*Advanced Search.*footer\.tmpl/s,"advanced search template dumped"); # test
is($cmd,"my nextCommand","passes nextCommand"); # test
is($query,"my nextQuery","passes no nextQuery"); # test
is($msg,"my noticeMsg","passes no noticeMsg"); # test

stdout_grab();
eval { ($cmd,$query,$msg)=$e->do_search(
		user => { },
		on => $main::testuid,
		table => 'user',
		data => { 'descriptor' => $main::testuser },
		command => 'test',
		nextCommand => 'my nextCommand',
		noticeMsg => 'my noticeMsg',
		nextQuery => 'my nextQuery',
	); }; # no data == "Advanced Search" on modulename
is($@,"","happy standard search"); # test
like(stdout_dump(),qr/main\.tmpl.*header\.tmpl.*test.all.page.tmpl.*footer\.tmpl/s,"standard search template dumped"); # test
is($cmd,"my nextCommand","passes nextCommand"); # test
is($query,"all","reports defaulted nextQuery"); # test
is($msg,"my noticeMsg","passes no noticeMsg"); # test

# do_tree

# do_single

# do_display
stdout_grab();
eval { ($cmd,$query,$msg)=$e->do_display(
	); }; # no data
like($@,qr/table name not given for/,"require table name"); # test
stdout_dump();

stdout_grab();
eval { ($cmd,$query,$msg)=$e->do_display(
	table => 'dne',
	modulename => 'users',
	on => 0,
	user => { Permissions => { admin => 'N' } },
	); };
like($@,qr/Cannot access record for/,"require admin privs"); # test
stdout_dump();

stdout_grab();
eval { ($cmd,$query,$msg)=$e->do_display(
		user => { },
		on => $main::testuid,
		table => 'user',
		data => { 'descriptor' => $main::testuser },
		command => 'test',
		nextCommand => 'my nextCommand',
		noticeMsg => 'my noticeMsg',
		nextQuery => 'my nextQuery',
	); };
like($@,qr/t know what the query 'all' means/,"require sane query"); # test
stdout_dump();

stdout_grab();
# clear args`
$e->{_ARGS} = {};
eval { ($cmd,$query,$msg)=$e->do_display(
		user => { },
		on => $main::testuid,
		table => 'user',
		data => { 'descriptor' => $main::testuser },
		command => 'test',
		nextCommand => 'my nextCommand',
		noticeMsg => 'my noticeMsg',
		nextQuery => 'my nextQuery',
	); };
is($@,"","happy standard display"); # test
like(stdout_dump(),qr/main\.tmpl.*header\.tmpl.*footer\.tmpl/s,"standard display template dumped"); # test
is($cmd,"my nextCommand","passes nextCommand"); # test
is($query,"all","reports defaulted nextQuery"); # test
is($msg,"my noticeMsg","passes no noticeMsg"); # test


stdout_grab();
# clear args
$e->{_ARGS} = {};
eval { ($cmd,$query,$msg)=$e->do_display(
		user => { },
		on => $main::testuid,
		table => 'user',
		data => { 'descriptor' => $main::testuser },
		command => 'test',
		nextCommand => 'my nextCommand',
		noticeMsg => 'my noticeMsg',
		nextQuery => 'my nextQuery',
	); }; # no data == "Advanced Search" on modulename
is($@,"","happy standard search"); # test
like(stdout_dump(),qr/main\.tmpl.*header\.tmpl.*footer\.tmpl/s,"standard display template dumped"); # test
is($cmd,"my nextCommand","passes nextCommand"); # test
is($query,"all","reports defaulted nextQuery"); # test
is($msg,"my noticeMsg","passes no noticeMsg"); # test



stdout_cleanup();
}



#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

sub stdout_grab
{
	open $oldout, ">&STDOUT" || die "Can't save STDOUT handle: $!\n";
	open(STDOUT,">$file") || die "Can't redirect STDOUT to $file: $!\n";
	select STDOUT; $|=1;
}

sub stdout_dump
{
	close(STDOUT) || die "Can't close redirected STDOUT: $!\n";
	open STDOUT, ">&", $oldout || die "Can't reopen STDOUT: $!\n";
	select STDOUT;
	return loadFile($file);
}

sub stdout_cleanup
{
	unlink($file);
}

1;
